#ifndef DISCRETEANGLE_H
#define DISCRETEANGLE_H

#include "Angle.h"
#include "Range.h"

// A fixed angle between (-180..180]

template <typename T> class AngleUsing {
public:
  AngleUsing(T sourceValue) { this->value = sourceValue; }
  AngleUsing(float f);
  float ToFloat() const;
  inline T GetValue() const { return this->value; }

  AngleUsing<T> operator+(const AngleUsing<T> a) {
    AngleUsing<T> r = AngleUsing((float)this->value + a.value);
    return r;
  }

  inline AngleUsing<T> operator+=(const AngleUsing<T> a) {
    return this->value + a.value;
  }

  inline AngleUsing<T> operator-(const AngleUsing<T> a) {
    return this->value - a.value;
  }

  inline AngleUsing<T> operator-() {
    this->value = -this->value;
    return *this;
  }

  inline bool operator==(const AngleUsing<T> a) {
    return this->value == a.value;
  }

  // protected:
  T value;
};

#endif
